# Generated from:
# https://github.com/zopefoundation/meta/tree/master/config/pure-python
[tox]
minversion = 3.18
envlist =
    lint
    py27
    py35
    py36
    py37
    py38
    py39
    py310
    py311
    pypy
    pypy3
    docs
    coverage
    py{27,35,36,37,38,39,310,311,py,py3}-subunit

[testenv]
usedevelop = true
deps =
commands =
    zope-testrunner --test-path=src {posargs:-vc}
extras =
    test
    subunit: subunit
    coverage: subunit

[testenv:lint]
basepython = python3
skip_install = true
commands =
    isort --check-only --diff {toxinidir}/src {toxinidir}/setup.py
    flake8 src setup.py
    check-manifest
    check-python-versions
deps =
    check-manifest
    check-python-versions >= 0.19.1
    wheel
    flake8
    isort

[testenv:isort-apply]
basepython = python3
skip_install = true
commands_pre =
deps =
    isort
commands =
    isort {toxinidir}/src {toxinidir}/setup.py []

[testenv:docs]
basepython = python3
skip_install = false
extras =
    docs
commands_pre =
commands =
    sphinx-build -b html -d docs/_build/doctrees docs docs/_build/html

[testenv:coverage]
basepython = python3
allowlist_externals =
    mkdir
deps =
    coverage
    coverage-python-version
commands =
    mkdir -p {toxinidir}/parts/htmlcov
    coverage run -m zope.testrunner --test-path=src {posargs:-vc}
    coverage html --ignore-errors
    coverage report --ignore-errors --show-missing --fail-under=84

[coverage:run]
branch = True
plugins = coverage_python_version
source = zope.testrunner

[coverage:report]
precision = 2
exclude_lines =
    pragma: no cover
    pragma: nocover
    except ImportError:
    raise NotImplementedError
    if __name__ == '__main__':
    self.fail
    raise AssertionError

[coverage:html]
directory = parts/htmlcov
